///O(VloglogV + NlogV + NlogN)
#include <bits/stdc++.h>
#define NMAX 200000
#define VMAX 10000000

using namespace std;

ifstream fi("basme.in");
ofstream fo("basme.out");

int n, arr[NMAX+5];
int xorOfFactors[NMAX+5];
bitset<VMAX+5> sieve;
int smallestFactor[VMAX+5];
map<int,int> countOfOccurences;

void read(){
    fi>>n;
    for(int i=1;i<=n;i++){
        fi>>arr[i];
    }
}

void getSmallestFact(){
    for(int i=2;i<=VMAX;i+=2){
        smallestFactor[i] = 2;
    }
    for(int i=3;i<=VMAX;i+=2){
        if(sieve[i]==0){
            smallestFactor[i] = i;
            if(1ULL*i*i<=VMAX){
                for(long long j=1LL*i*i;j<=VMAX;j+=i){
                    if(smallestFactor[j]==0){
                        smallestFactor[j] = i;
                        sieve[j] = 1;
                    }
                }
            }
        }
    }
}

int getXorOfFactors(int nr){
    int ret = 0, d;
    while (nr>1) {
        d = smallestFactor[nr];
        ret ^= d;
        while (nr%d==0){
            nr/=d;
        }
    }
    return ret;
}

void getArrayOfXoredFactors(){
    for(int i=1;i<=n;i++){
        xorOfFactors[i] = getXorOfFactors(arr[i]);
    }
}

long long getNumberOfSequences(){
    countOfOccurences[0] = 1;
    int xor_sum = 0;
    long long total_number = 0;
    for(int i=1;i<=n;i++){
        xor_sum ^= xorOfFactors[i];
        total_number += countOfOccurences[xor_sum];
        countOfOccurences[xor_sum] += 1;
    }
    return total_number;
}

int main(){
    read();
    getSmallestFact();
    getArrayOfXoredFactors();
    fo<<getNumberOfSequences();
    fi.close();
    fo.close();
}