//O(Vlog(log(V))) + sqrt(V)/log(sqrt(V))*log(V)*N + NlogN)
#include <bits/stdc++.h>
#define NMAX 200000
#define VMAX 10000000
#define SQVMAX 10000

using namespace std;

ifstream fi("basme.in");
ofstream fo("basme.out");

int n, a[NMAX+5];
long long fact_xored[NMAX+5];
bitset<VMAX+5> sieve;
int primes[VMAX], lprimes;
map<int,int> count_xor;

void read(){
    fi>>n;
    for(int i=1;i<=n;i++){
        fi>>a[i];
    }
}


void get_primes(){
    for(int i=4;i<=VMAX;i+=2){
        sieve[i] = 1;
    }
    primes[++lprimes] = 2;
    for(int i=3;i<=SQVMAX;i+=2){
        if(sieve[i]==0){
            primes[++lprimes] = i;
            for(int j=i*i;j<=VMAX;j+=i){
                sieve[j] = 1;
            }
        }
    }
}

long long get_xor_of_factors(long long nr){
    long long ret = 0, d = 1;
    while (d<=lprimes&&nr>1 && primes[d]*primes[d]<=nr) {
        if (nr % primes[d] == 0) {
            ret ^= primes[d];
        }
        while (nr%primes[d]==0) {
            nr/=primes[d];
        }
        d ++;
    }
    if(nr>1){
        ret^=nr;
    }
    return ret;
}

void get_array_of_fact_xored(){
    for(int i=1;i<=n;i++){
        fact_xored[i] = get_xor_of_factors(a[i]);
    }
}

long long get_number_of_sequences(){
    count_xor[0] = 1;
    int xor_sum = 0;
    long long total_number = 0;
    for(int i=1;i<=n;i++){
        xor_sum ^= fact_xored[i];
        total_number += 1LL*count_xor[xor_sum];
        count_xor[xor_sum] += 1;
    }
    return total_number;
}


int main(){
    read();
    get_primes();
    get_array_of_fact_xored();
    fo<<get_number_of_sequences();
    fi.close();
    fo.close();
}